@rem = '--*-Perl-*--
@echo off
if "%OS%" == "Windows_NT" goto WinNT
perl -x -S "%0" %1 %2 %3 %4 %5 %6 %7 %8 %9
goto endofperl
:WinNT
perl -x -S %0 %*
if NOT "%COMSPEC%" == "%SystemRoot%\system32\cmd.exe" goto endofperl
if %errorlevel% == 9009 echo You do not have Perl in your PATH.
if errorlevel 1 goto script_failed_so_exit_with_non_zero_val 2>nul
goto endofperl
@rem ';
#!/bin/perl
#line 15
use strict;
use warnings;
use English;
use Config;
use File::Find 'find';
use File::Copy 'copy';
use File::Spec;
use File::Basename qw/basename dirname/;

my $err = 0;

my $dir = dirname(File::Spec->rel2abs($0));
$dir =~ s#\\#/#g;
# print "$dir\n";

my $ver = $English::PERL_VERSION;
print "RERP_VERSION : $ver\n";
print "OSNAME       : $English::OSNAME\n";
print "osvers       : $Config{'osvers'}\n";
print "archname     : $Config{'archname'}\n";
print "OS           : $ENV{OS}\n" if defined($ENV{OS});

my $arc = "$dir";
my $namazu = "C:/namazu";
my $kakasi = "C:/kakasi";

my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
$year += 1900;
$mon += 1;
my $date = sprintf("%.4d%.2d%.2d%.2d%.2d%.2d", $year, $mon, $mday, $hour, $min, $sec);
my $back_namazu = "C:/namazu_$date";
my $back_kakasi = "C:/kakasi_$date";
my $work_namazu = "C:/namazu_work_$date";
my $work_kakasi = "C:/kakasi_work_$date";

if (-e $kakasi) {
    print "$kakasi fBNgɑ݂܂B\n";
    print "$back_kakasi Ƀl[܂B\n";
    if (!rename($kakasi, $back_kakasi)) {
		$err = 1;
		printf "Error: l[s: $kakasi\n";
		input_key();
		exit 1;
    }
}
if (-e $namazu) {
    print "$namazu fBNgɑ݂܂B\n";
    print "$back_namazu Ƀl[܂B\n";
    if (!rename($namazu, $back_namazu)) {
		$err = 1;
		printf "Error: l[s: $namazu\n";
		input_key();
		exit 1;
    }
}

my $top_dir;
my $dir_copy_to;


#
# copy kakasi
#

$top_dir = "$arc/kakasi";
$dir_copy_to = $work_kakasi;
print "kakasi Rs[\n";
$OUTPUT_AUTOFLUSH = 1;
find(\&recursive_copy, $top_dir);
print "\n";
$OUTPUT_AUTOFLUSH = 0;

if (!rename($work_kakasi, $kakasi)) {
	$err = 1;
	printf "Error: l[s: $work_kakasi\n";
}


#
# copy namazu
#

$top_dir = "$arc/namazu";
$dir_copy_to = $work_namazu;
print "namazu Rs[\n";
$OUTPUT_AUTOFLUSH = 1;
find(\&recursive_copy, $top_dir);
print "\n";
$OUTPUT_AUTOFLUSH = 0;

if (!rename($work_namazu, $namazu)) {
	$err = 1;
	printf "Error: l[s: $work_namazu\n";
}


if ($err == 0) {
	print "Rs[I܂B\n";
	print " PPM CXg[ĂB\n";
}
else {
	print "Rs[Ɏs܂B\n";
}
input_key();


sub recursive_copy 
{
  my $file_from = $_;

  my $file_to = $File::Find::name;       
  $file_to =~ s#^$top_dir#$dir_copy_to#;
                                        
  if (-d $file_from) {
    print "o";
    mkdir $file_to or die "$file_to 쐬邱Ƃł܂B\n";
  }
  else {
    copy $file_from, $file_to or die "$file_from  $file_to ɃRs[邱Ƃł܂B\n";
  }
}

sub input_key
{
	my $line;
	
	print "\n";
	print "uEntervL[͂ĂB\n";
	$line = <STDIN>;
}

__END__
:endofperl
